//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: cosmos/group/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query is the cosmos.group.v1beta1 Query service.
///
/// Usage: instantiate `Cosmos_Group_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Cosmos_Group_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Cosmos_Group_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func groupInfo(
    _ request: Cosmos_Group_V1beta1_QueryGroupInfoRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupInfoRequest, Cosmos_Group_V1beta1_QueryGroupInfoResponse>

  func groupAccountInfo(
    _ request: Cosmos_Group_V1beta1_QueryGroupAccountInfoRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupAccountInfoRequest, Cosmos_Group_V1beta1_QueryGroupAccountInfoResponse>

  func groupMembers(
    _ request: Cosmos_Group_V1beta1_QueryGroupMembersRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupMembersRequest, Cosmos_Group_V1beta1_QueryGroupMembersResponse>

  func groupsByAdmin(
    _ request: Cosmos_Group_V1beta1_QueryGroupsByAdminRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupsByAdminRequest, Cosmos_Group_V1beta1_QueryGroupsByAdminResponse>

  func groupAccountsByGroup(
    _ request: Cosmos_Group_V1beta1_QueryGroupAccountsByGroupRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupAccountsByGroupRequest, Cosmos_Group_V1beta1_QueryGroupAccountsByGroupResponse>

  func groupAccountsByAdmin(
    _ request: Cosmos_Group_V1beta1_QueryGroupAccountsByAdminRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupAccountsByAdminRequest, Cosmos_Group_V1beta1_QueryGroupAccountsByAdminResponse>

  func proposal(
    _ request: Cosmos_Group_V1beta1_QueryProposalRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryProposalRequest, Cosmos_Group_V1beta1_QueryProposalResponse>

  func proposalsByGroupAccount(
    _ request: Cosmos_Group_V1beta1_QueryProposalsByGroupAccountRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryProposalsByGroupAccountRequest, Cosmos_Group_V1beta1_QueryProposalsByGroupAccountResponse>

  func voteByProposalVoter(
    _ request: Cosmos_Group_V1beta1_QueryVoteByProposalVoterRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryVoteByProposalVoterRequest, Cosmos_Group_V1beta1_QueryVoteByProposalVoterResponse>

  func votesByProposal(
    _ request: Cosmos_Group_V1beta1_QueryVotesByProposalRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryVotesByProposalRequest, Cosmos_Group_V1beta1_QueryVotesByProposalResponse>

  func votesByVoter(
    _ request: Cosmos_Group_V1beta1_QueryVotesByVoterRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryVotesByVoterRequest, Cosmos_Group_V1beta1_QueryVotesByVoterResponse>
}

extension Cosmos_Group_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "cosmos.group.v1beta1.Query"
  }

  /// GroupInfo queries group info based on group id.
  ///
  /// - Parameters:
  ///   - request: Request to send to GroupInfo.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func groupInfo(
    _ request: Cosmos_Group_V1beta1_QueryGroupInfoRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupInfoRequest, Cosmos_Group_V1beta1_QueryGroupInfoResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/GroupInfo",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGroupInfoInterceptors() ?? []
    )
  }

  /// GroupAccountInfo queries group account info based on group account address.
  ///
  /// - Parameters:
  ///   - request: Request to send to GroupAccountInfo.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func groupAccountInfo(
    _ request: Cosmos_Group_V1beta1_QueryGroupAccountInfoRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupAccountInfoRequest, Cosmos_Group_V1beta1_QueryGroupAccountInfoResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/GroupAccountInfo",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGroupAccountInfoInterceptors() ?? []
    )
  }

  /// GroupMembers queries members of a group
  ///
  /// - Parameters:
  ///   - request: Request to send to GroupMembers.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func groupMembers(
    _ request: Cosmos_Group_V1beta1_QueryGroupMembersRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupMembersRequest, Cosmos_Group_V1beta1_QueryGroupMembersResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/GroupMembers",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGroupMembersInterceptors() ?? []
    )
  }

  /// GroupsByAdmin queries groups by admin address.
  ///
  /// - Parameters:
  ///   - request: Request to send to GroupsByAdmin.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func groupsByAdmin(
    _ request: Cosmos_Group_V1beta1_QueryGroupsByAdminRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupsByAdminRequest, Cosmos_Group_V1beta1_QueryGroupsByAdminResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/GroupsByAdmin",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGroupsByAdminInterceptors() ?? []
    )
  }

  /// GroupAccountsByGroup queries group accounts by group id.
  ///
  /// - Parameters:
  ///   - request: Request to send to GroupAccountsByGroup.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func groupAccountsByGroup(
    _ request: Cosmos_Group_V1beta1_QueryGroupAccountsByGroupRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupAccountsByGroupRequest, Cosmos_Group_V1beta1_QueryGroupAccountsByGroupResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/GroupAccountsByGroup",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGroupAccountsByGroupInterceptors() ?? []
    )
  }

  /// GroupsByAdmin queries group accounts by admin address.
  ///
  /// - Parameters:
  ///   - request: Request to send to GroupAccountsByAdmin.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func groupAccountsByAdmin(
    _ request: Cosmos_Group_V1beta1_QueryGroupAccountsByAdminRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryGroupAccountsByAdminRequest, Cosmos_Group_V1beta1_QueryGroupAccountsByAdminResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/GroupAccountsByAdmin",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGroupAccountsByAdminInterceptors() ?? []
    )
  }

  /// Proposal queries a proposal based on proposal id.
  ///
  /// - Parameters:
  ///   - request: Request to send to Proposal.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func proposal(
    _ request: Cosmos_Group_V1beta1_QueryProposalRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryProposalRequest, Cosmos_Group_V1beta1_QueryProposalResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/Proposal",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeProposalInterceptors() ?? []
    )
  }

  /// ProposalsByGroupAccount queries proposals based on group account address.
  ///
  /// - Parameters:
  ///   - request: Request to send to ProposalsByGroupAccount.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func proposalsByGroupAccount(
    _ request: Cosmos_Group_V1beta1_QueryProposalsByGroupAccountRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryProposalsByGroupAccountRequest, Cosmos_Group_V1beta1_QueryProposalsByGroupAccountResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/ProposalsByGroupAccount",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeProposalsByGroupAccountInterceptors() ?? []
    )
  }

  /// VoteByProposalVoter queries a vote by proposal id and voter.
  ///
  /// - Parameters:
  ///   - request: Request to send to VoteByProposalVoter.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func voteByProposalVoter(
    _ request: Cosmos_Group_V1beta1_QueryVoteByProposalVoterRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryVoteByProposalVoterRequest, Cosmos_Group_V1beta1_QueryVoteByProposalVoterResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/VoteByProposalVoter",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeVoteByProposalVoterInterceptors() ?? []
    )
  }

  /// VotesByProposal queries a vote by proposal.
  ///
  /// - Parameters:
  ///   - request: Request to send to VotesByProposal.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func votesByProposal(
    _ request: Cosmos_Group_V1beta1_QueryVotesByProposalRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryVotesByProposalRequest, Cosmos_Group_V1beta1_QueryVotesByProposalResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/VotesByProposal",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeVotesByProposalInterceptors() ?? []
    )
  }

  /// VotesByVoter queries a vote by voter.
  ///
  /// - Parameters:
  ///   - request: Request to send to VotesByVoter.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func votesByVoter(
    _ request: Cosmos_Group_V1beta1_QueryVotesByVoterRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Group_V1beta1_QueryVotesByVoterRequest, Cosmos_Group_V1beta1_QueryVotesByVoterResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.group.v1beta1.Query/VotesByVoter",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeVotesByVoterInterceptors() ?? []
    )
  }
}

internal protocol Cosmos_Group_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'groupInfo'.
  func makeGroupInfoInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryGroupInfoRequest, Cosmos_Group_V1beta1_QueryGroupInfoResponse>]

  /// - Returns: Interceptors to use when invoking 'groupAccountInfo'.
  func makeGroupAccountInfoInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryGroupAccountInfoRequest, Cosmos_Group_V1beta1_QueryGroupAccountInfoResponse>]

  /// - Returns: Interceptors to use when invoking 'groupMembers'.
  func makeGroupMembersInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryGroupMembersRequest, Cosmos_Group_V1beta1_QueryGroupMembersResponse>]

  /// - Returns: Interceptors to use when invoking 'groupsByAdmin'.
  func makeGroupsByAdminInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryGroupsByAdminRequest, Cosmos_Group_V1beta1_QueryGroupsByAdminResponse>]

  /// - Returns: Interceptors to use when invoking 'groupAccountsByGroup'.
  func makeGroupAccountsByGroupInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryGroupAccountsByGroupRequest, Cosmos_Group_V1beta1_QueryGroupAccountsByGroupResponse>]

  /// - Returns: Interceptors to use when invoking 'groupAccountsByAdmin'.
  func makeGroupAccountsByAdminInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryGroupAccountsByAdminRequest, Cosmos_Group_V1beta1_QueryGroupAccountsByAdminResponse>]

  /// - Returns: Interceptors to use when invoking 'proposal'.
  func makeProposalInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryProposalRequest, Cosmos_Group_V1beta1_QueryProposalResponse>]

  /// - Returns: Interceptors to use when invoking 'proposalsByGroupAccount'.
  func makeProposalsByGroupAccountInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryProposalsByGroupAccountRequest, Cosmos_Group_V1beta1_QueryProposalsByGroupAccountResponse>]

  /// - Returns: Interceptors to use when invoking 'voteByProposalVoter'.
  func makeVoteByProposalVoterInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryVoteByProposalVoterRequest, Cosmos_Group_V1beta1_QueryVoteByProposalVoterResponse>]

  /// - Returns: Interceptors to use when invoking 'votesByProposal'.
  func makeVotesByProposalInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryVotesByProposalRequest, Cosmos_Group_V1beta1_QueryVotesByProposalResponse>]

  /// - Returns: Interceptors to use when invoking 'votesByVoter'.
  func makeVotesByVoterInterceptors() -> [ClientInterceptor<Cosmos_Group_V1beta1_QueryVotesByVoterRequest, Cosmos_Group_V1beta1_QueryVotesByVoterResponse>]
}

internal final class Cosmos_Group_V1beta1_QueryClient: Cosmos_Group_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Cosmos_Group_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the cosmos.group.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Cosmos_Group_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query is the cosmos.group.v1beta1 Query service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Cosmos_Group_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Cosmos_Group_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// GroupInfo queries group info based on group id.
  func groupInfo(request: Cosmos_Group_V1beta1_QueryGroupInfoRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryGroupInfoResponse>

  /// GroupAccountInfo queries group account info based on group account address.
  func groupAccountInfo(request: Cosmos_Group_V1beta1_QueryGroupAccountInfoRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryGroupAccountInfoResponse>

  /// GroupMembers queries members of a group
  func groupMembers(request: Cosmos_Group_V1beta1_QueryGroupMembersRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryGroupMembersResponse>

  /// GroupsByAdmin queries groups by admin address.
  func groupsByAdmin(request: Cosmos_Group_V1beta1_QueryGroupsByAdminRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryGroupsByAdminResponse>

  /// GroupAccountsByGroup queries group accounts by group id.
  func groupAccountsByGroup(request: Cosmos_Group_V1beta1_QueryGroupAccountsByGroupRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryGroupAccountsByGroupResponse>

  /// GroupsByAdmin queries group accounts by admin address.
  func groupAccountsByAdmin(request: Cosmos_Group_V1beta1_QueryGroupAccountsByAdminRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryGroupAccountsByAdminResponse>

  /// Proposal queries a proposal based on proposal id.
  func proposal(request: Cosmos_Group_V1beta1_QueryProposalRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryProposalResponse>

  /// ProposalsByGroupAccount queries proposals based on group account address.
  func proposalsByGroupAccount(request: Cosmos_Group_V1beta1_QueryProposalsByGroupAccountRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryProposalsByGroupAccountResponse>

  /// VoteByProposalVoter queries a vote by proposal id and voter.
  func voteByProposalVoter(request: Cosmos_Group_V1beta1_QueryVoteByProposalVoterRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryVoteByProposalVoterResponse>

  /// VotesByProposal queries a vote by proposal.
  func votesByProposal(request: Cosmos_Group_V1beta1_QueryVotesByProposalRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryVotesByProposalResponse>

  /// VotesByVoter queries a vote by voter.
  func votesByVoter(request: Cosmos_Group_V1beta1_QueryVotesByVoterRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Group_V1beta1_QueryVotesByVoterResponse>
}

extension Cosmos_Group_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "cosmos.group.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "GroupInfo":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryGroupInfoRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryGroupInfoResponse>(),
        interceptors: self.interceptors?.makeGroupInfoInterceptors() ?? [],
        userFunction: self.groupInfo(request:context:)
      )

    case "GroupAccountInfo":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryGroupAccountInfoRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryGroupAccountInfoResponse>(),
        interceptors: self.interceptors?.makeGroupAccountInfoInterceptors() ?? [],
        userFunction: self.groupAccountInfo(request:context:)
      )

    case "GroupMembers":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryGroupMembersRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryGroupMembersResponse>(),
        interceptors: self.interceptors?.makeGroupMembersInterceptors() ?? [],
        userFunction: self.groupMembers(request:context:)
      )

    case "GroupsByAdmin":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryGroupsByAdminRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryGroupsByAdminResponse>(),
        interceptors: self.interceptors?.makeGroupsByAdminInterceptors() ?? [],
        userFunction: self.groupsByAdmin(request:context:)
      )

    case "GroupAccountsByGroup":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryGroupAccountsByGroupRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryGroupAccountsByGroupResponse>(),
        interceptors: self.interceptors?.makeGroupAccountsByGroupInterceptors() ?? [],
        userFunction: self.groupAccountsByGroup(request:context:)
      )

    case "GroupAccountsByAdmin":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryGroupAccountsByAdminRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryGroupAccountsByAdminResponse>(),
        interceptors: self.interceptors?.makeGroupAccountsByAdminInterceptors() ?? [],
        userFunction: self.groupAccountsByAdmin(request:context:)
      )

    case "Proposal":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryProposalRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryProposalResponse>(),
        interceptors: self.interceptors?.makeProposalInterceptors() ?? [],
        userFunction: self.proposal(request:context:)
      )

    case "ProposalsByGroupAccount":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryProposalsByGroupAccountRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryProposalsByGroupAccountResponse>(),
        interceptors: self.interceptors?.makeProposalsByGroupAccountInterceptors() ?? [],
        userFunction: self.proposalsByGroupAccount(request:context:)
      )

    case "VoteByProposalVoter":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryVoteByProposalVoterRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryVoteByProposalVoterResponse>(),
        interceptors: self.interceptors?.makeVoteByProposalVoterInterceptors() ?? [],
        userFunction: self.voteByProposalVoter(request:context:)
      )

    case "VotesByProposal":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryVotesByProposalRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryVotesByProposalResponse>(),
        interceptors: self.interceptors?.makeVotesByProposalInterceptors() ?? [],
        userFunction: self.votesByProposal(request:context:)
      )

    case "VotesByVoter":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Group_V1beta1_QueryVotesByVoterRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Group_V1beta1_QueryVotesByVoterResponse>(),
        interceptors: self.interceptors?.makeVotesByVoterInterceptors() ?? [],
        userFunction: self.votesByVoter(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Cosmos_Group_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'groupInfo'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGroupInfoInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryGroupInfoRequest, Cosmos_Group_V1beta1_QueryGroupInfoResponse>]

  /// - Returns: Interceptors to use when handling 'groupAccountInfo'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGroupAccountInfoInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryGroupAccountInfoRequest, Cosmos_Group_V1beta1_QueryGroupAccountInfoResponse>]

  /// - Returns: Interceptors to use when handling 'groupMembers'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGroupMembersInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryGroupMembersRequest, Cosmos_Group_V1beta1_QueryGroupMembersResponse>]

  /// - Returns: Interceptors to use when handling 'groupsByAdmin'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGroupsByAdminInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryGroupsByAdminRequest, Cosmos_Group_V1beta1_QueryGroupsByAdminResponse>]

  /// - Returns: Interceptors to use when handling 'groupAccountsByGroup'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGroupAccountsByGroupInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryGroupAccountsByGroupRequest, Cosmos_Group_V1beta1_QueryGroupAccountsByGroupResponse>]

  /// - Returns: Interceptors to use when handling 'groupAccountsByAdmin'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGroupAccountsByAdminInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryGroupAccountsByAdminRequest, Cosmos_Group_V1beta1_QueryGroupAccountsByAdminResponse>]

  /// - Returns: Interceptors to use when handling 'proposal'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeProposalInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryProposalRequest, Cosmos_Group_V1beta1_QueryProposalResponse>]

  /// - Returns: Interceptors to use when handling 'proposalsByGroupAccount'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeProposalsByGroupAccountInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryProposalsByGroupAccountRequest, Cosmos_Group_V1beta1_QueryProposalsByGroupAccountResponse>]

  /// - Returns: Interceptors to use when handling 'voteByProposalVoter'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeVoteByProposalVoterInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryVoteByProposalVoterRequest, Cosmos_Group_V1beta1_QueryVoteByProposalVoterResponse>]

  /// - Returns: Interceptors to use when handling 'votesByProposal'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeVotesByProposalInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryVotesByProposalRequest, Cosmos_Group_V1beta1_QueryVotesByProposalResponse>]

  /// - Returns: Interceptors to use when handling 'votesByVoter'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeVotesByVoterInterceptors() -> [ServerInterceptor<Cosmos_Group_V1beta1_QueryVotesByVoterRequest, Cosmos_Group_V1beta1_QueryVotesByVoterResponse>]
}
